import csv
import json
import urllib.request
from cement import Controller, ex
from cement.utils import fs
import urllib.request
from benchgrape.core.db import TestDataMapper
from benchgrape.core.utils import DEFAULT_TOKEN_LOCATION


class TestData(Controller):
    class Meta:
        label = 'tokens'
        stacked_type = 'nested'
        stacked_on = 'base'

    @ex(help='Download Test Data File generated by '
             'chatgrape\'s create_benchgrape_data command. '
             '(python manage.py create_benchgrape_data)',
        arguments=[
            (['--url'], {
                'help': 'URL you got from create_benchgrape_data',
                'action': 'store'
            })
        ],
        )
    def download(self):
        url = self.app.pargs.url
        self.app.log.info(f'downloading tokens file from {url}...')
        urllib.request.urlretrieve(
            url, DEFAULT_TOKEN_LOCATION
        )
        self.app.log.info(f'done. saved as {DEFAULT_TOKEN_LOCATION}...')
